## Notebook Examples

This is a list of currently available example notebooks for `Clapeyron.jl`:

- [Ideal Equations of State](https://nbviewer.org/github/ypaul21/Clapeyron.jl/blob/master/examples/ideal_eos.ipynb): Examples of how one can use ideal equations of state within `Clapeyron.jl`, whether it be supplementing a residual equation of state or independently.

- [Cubic equations of state](https://nbviewer.org/github/ypaul21/Clapeyron.jl/blob/master/examples/cubic_eos.ipynb): Examples of how one can use cubic equations of state, along with customizing those with different α-functions, Volume translation or mixing rules.

- [SAFT equations of state](https://nbviewer.org/github/ypaul21/Clapeyron.jl/blob/master/examples/SAFT_eos.ipynb): Examples of how one can use SAFT-type equations.

- [Activity models](https://nbviewer.org/github/ypaul21/Clapeyron.jl/blob/master/examples/activity_models.ipynb): Examples on how to use activity models, standalone or as a mixing rule in a cubic equation of state.

- [User defined equations of state](https://nbviewer.org/github/ypaul21/Clapeyron.jl/blob/master/examples/user_defined_eos.ipynb): Example of how to implement a new equation of state within `Clapeyron.jl`. In this case will be the SAFT-VR Mie+AT model developed by *Walker et al*. which is simply a modification of the regular SAFT-VR Mie equation of state.

- [Miscellaneous pure vapour-liquid equilibrium properties](https://nbviewer.org/github/ypaul21/Clapeyron.jl/blob/master/examples/pure_vle_properties.ipynb): Examples of pure component vapour-liquid equilibrium properties

- [Mixing functions](https://nbviewer.org/github/ypaul21/Clapeyron.jl/blob/master/examples/mixing_functions.ipynb): Examples of calculation of mixing and excess properties

- [Multi-component equilibrium and critical points](https://nbviewer.org/github/ypaul21/Clapeyron.jl/blob/master/examples/multi-component_vle_vlle_lle_crit.ipynb): Examples of the various equilibrium and critical properties. focused on the uncommon, more-complex types of diagrams.

- [Differential Evolution Flash Algorithm in `Clapeyron.jl`](https://nbviewer.org/github/ypaul21/Clapeyron.jl/blob/master/examples/PTFlashDifferentialEvolution.ipynb): demonstration of a multicomponent flash algorithm for use with `Clapeyron.jl`, which utilizes the excellent differential evolution black box optimization algorithms in `BlackBoxOptim.jl`.

