const GERG2008_names=[
        "methane",
        "nitrogen",
        "carbon dioxide",
        "ethane",
        "propane",
        "butane",
        "isobutane",
        "pentane",
        "isopentane",
        "hexane",
        "heptane",
        "octane",
        "nonane",
        "decane",
        "hydrogen",
        "oxygen",
        "carbon monoxide",
        "water",
        "hydrogen sulfide",
        "helium",
        "argon"
        ]

function getparams_gerg2008()

    components =[
            "methane",
            "nitrogen",
            "carbon dioxide",
            "ethane",
            "propane",
            "butane",
            "isobutane",
            "pentane",
            "isopentane",
            "hexane",
            "heptane",
            "octane",
            "nonane",
            "decane",
            "hydrogen",
            "oxygen",
            "carbon monoxide",
            "water",
            "hydrogen sulfide",
            "helium",
            "argon"
            ]

    lb_v = SingleParam("lower bound volume",components,[
        2.952789230664869e-5
        2.595917396536852e-5
        3.0350520997504374e-5
        4.181265338895899e-5
        5.7773265228561896e-5
        7.778071972263543e-5
        7.529511394064539e-5
        9.03473213517436e-5
        9.138272716465976e-5
        0.00010746846161549492
        0.00012307769607878738
        0.00014149360905504386
        0.00013613745434844812
        0.00015142994339404644
        1.6005013101722185e-5
        2.3229544237311946e-5
        2.9381748144372254e-5
        1.732307538792257e-5
        3.154736660208043e-5
        1.2820394828598075e-5
        2.511877404958246e-5
    ])
    acentricfactor = SingleParam("acentric factor",components,[
            0.0115478,
            0.0377215,
            0.223621,
            0.099493,
            0.152291,
            0.183521,
            0.200164,
            0.227875,
            0.251506,
            0.301261,
            0.349469,
            0.399552,
            0.44346,
            0.492328,
            -0.215993,
            0.0221798,
            0.0481621,
            0.344861,
            0.0941677,
            -0.390032,
            0.0,
        ])
        Mw = SingleParam("Molecular weight",components,[
            16.04246,
            28.0134,
            44.0095,
            30.06904,
            44.09562,
            58.1222,
            58.1222,
            72.14878,
            72.14878,
            86.17536,
            100.20194,
            114.22852,
            128.2551,
            142.28168,
            2.01588,
            31.9988,
            28.0101,
            18.01528,
            34.08088,
            4.002602,
            39.948,
        ])
        Tc = SingleParam("Critical Temperature (K)",components,[
            190.564,
            126.192,
            304.1282,
            305.322,
            369.825,
            425.125,
            407.817,
            469.7,
            460.35,
            507.82,
            540.13,
            569.32,
            594.55,
            617.7,
            33.19,
            154.595,
            132.86,
            647.096,
            373.1,
            5.1953,
            150.687,
        ])
        rhoc = SingleParam("Critical density (mol/dm3)",components,[
            10.139342719,
            11.1839,
            10.624978698,
            6.87085454,
            5.000043088,
            3.920016792,
            3.86014294,
            3.215577588,
            3.271,
            2.705877875,
            2.315324434,
            2.056404127,
            1.81,
            1.64,
            14.94,
            13.63,
            10.85,
            17.87371609,
            10.19,
            17.399,
            13.407429659,
        ]) 
        pc = SingleParam("Critical pressure (pa)",components,[
            4599000.,
            3400000.,
            7383000.,
            4872000.,
            4248000.,
            3640000.,
            3796000.,
            3380000.,
            3370000.,
            3025000.,
            2740000.,
            2490000.,
            2290000.,
            2110000.,
            1313000.,
            5043000.,
            3499000.,
            22064000.,
            8962910.,
            117000.,
            4898000.,
        ])

    n0 = SingleParam("n⁰",components,[
        (19.597508817, -83.959667892, 3.00088, 0.76315, 0.00460, 8.74432, -4.46921), #methane
        (11.083407489, -22.202102428, 2.50031, 0.13732, -0.14660, 0.90066, 0.0),     #nitrogen
        (11.925152758, -16.118762264, 2.50002, 2.04452, -1.06044, 2.03366, 0.01393),  #carbon dioxide
        (24.675437527, -77.425313760, 3.00263, 4.33939, 1.23722, 13.19740, -6.01989), #ethane
        (31.602908195, -84.463284382, 3.02939, 6.60569, 3.19700, 19.19210, -8.37267), #propane
        (20.884143364, -91.638478026, 3.33944, 9.44893, 6.89406, 24.46180, 14.78240), #n-butane
        (20.413726078, -94.467620036, 3.06714, 8.97575, 5.25156, 25.14230, 16.13880), #iso-butane
        (14.536611217, -89.919548319, 3.00000, 8.95043, 21.83600, 33.40320, 0.0),     #n-pentane
        (15.449907693, -101.298172792, 3.00000, 11.76180, 20.11010, 33.16880, 0.0),   #isopentane
        (14.345969349, -96.165722367, 3.00000, 11.69770, 26.81420, 38.61640, 0.0),    #n-hexane
        (15.063786601, -97.345252349, 3.00000, 13.72660, 30.47070, 43.55610, 0.0),    #n-heptane
        (15.864687161, -97.370667555, 3.00000, 15.68650, 33.80290, 48.17310, 0.0),   #n-octane
        (16.313913248, -102.160247463, 3.00000, 18.02410, 38.12350, 53.34150, 0.0),  #n-nonane
        (15.870791919, -108.858547525, 3.00000, 21.00690, 43.49310, 58.36570, 0.0),       #n-decane
        (13.796443393, -175.864487294, 1.47906, 0.95806, 0.45444, 1.56039, -1.37560), #hydrogen
        (10.001843586, -14.996095135, 2.50146, 1.07558, 1.01334, 0.0, 0.0),           #oxygen
        (10.813340744, -19.834733959, 2.50055, 1.02865, 0.00493, 0.0, 0.0),           #carbon monoxide
        (8.203520690, -11.996306443, 3.00392, 0.01059, 0.98763, 3.06904, 0.0),            #water
        (9.336197742, -16.266508995, 3.00000, 3.11942, 1.00243, 0.0, 0.0),            #hydrogen sulfide
        (13.628409737, -143.470759602, 1.50000, 0.0, 0.0, 0.0, 0.0),                  #helium
        (8.316631500, -4.946502600, 1.50000, 0.0, 0.0, 0.0, 0.0),                      #argon
    ])

    theta = SingleParam("ϑ",components,[
        (4.306474465, 0.936220902, 5.577233895, 5.722644361),                  #methane
        (5.251822620, -5.393067706, 13.788988208, 0.),                        #nitrogen
        (3.022758166, -2.844425476, 1.589964364, 1.121596090),               #carbon dioxide
        (1.831882406, 0.731306621, 3.378007481, 3.508721939),                #ethane
        (1.297521801, 0.543210978, 2.583146083, 2.777773271),                #propane
        (1.101487798, 0.431957660, 4.502440459, 2.124516319),                #n-butane
        (1.074673199, 0.485556021, 4.671261865, 2.191583480),                #isobutane
        (0.380391739, 1.789520971, 3.777411113, 0.),                          #n-pentane
        (0.635392636, 1.977271641, 4.169371131, 0.),                          #isopentane
        (0.359036667, 1.691951873, 3.596924107, 0.),                          #n-hexane
        (0.314348398, 1.548136560, 3.259326458, 0.),                          #n-heptane
        (0.279143540, 1.431644769, 2.973845992, 0.),                          #n-octane
        (0.263819696, 1.370586158, 2.848860483, 0.),                          #n-nonane
        (0.267034159, 1.353835195, 2.833479035, 0.),                          #n-decane
        (6.891654113, 9.847634830, 49.765290750, 50.367279301),              #hydrogen
        (14.461722565, 7.223325463, 0., 0.),                                   #oxygen
        (11.669802800, 5.302762306, 0., 0.),                                   #carbon monoxide
        (0.415386589, 1.763895929, 3.874803739, 0.),                          #water
        (4.914580541, 2.270653980, 0., 0.),                                    #hydrogen sulfide
        (0.0, 0., 0.0, 0.0),                                                  #helium
        (0.0, 0., 0.0, 0.0),                                                  #argon
    ])

        
    gamma_T = PairParam("γ_T",components,
    [1.0       0.979273  0.975665  1.04971   1.09866   1.17161   1.16112   1.24917   1.1889    1.33057   1.37985   1.44925   1.52853  1.56823   1.35264  0.95      0.987473  0.775811  0.961156  3.15978  0.989843
    0.979273  1.0       1.10765   1.09865   1.20126   1.30489   1.28446   1.41903   1.38177   1.47261   1.52098   1.73328   1.74912  1.82216   1.1757   0.993425  0.968808  0.995157  0.960174  1.47183  0.990035
    0.975665  1.10765   1.0       0.90095   0.908772  0.911498  0.929983  0.979217  0.961218  1.03868   1.04617   1.07446   1.14067  1.14551   1.78292  1.0       1.0       0.775454  0.926019  3.20746  1.05097
    1.04971   1.09865   0.90095   1.0       1.01473   1.03483   1.03328   1.06667   1.02115   1.09218   1.13453   1.16864   1.05603  1.23719   1.90201  1.0       1.06922   1.0       0.902737  1.0      1.0
    1.09866   1.20126   0.908772  1.01473   1.0       1.00739   1.00525   1.00834   1.00327   1.02566   1.05004   1.06369   1.10997  1.14091   2.30822  1.0       1.19756   0.600341  0.905829  1.0      1.0
    1.17161   1.30489   0.911498  1.03483   1.00739   1.0       1.00143   1.00214   1.00079   1.00916   1.02128   1.03318   1.0141   1.07647   2.50926  1.0       1.17392   0.615513  0.926157  1.0      1.24504
    1.16112   1.28446   0.929983  1.03328   1.00525   1.00143   1.0       1.0025    1.00184   1.00602   1.00989   1.01395   1.01782  1.02162   1.89531  1.0       1.16139   1.0       0.937131  1.0      1.0
    1.24917   1.41903   0.979217  1.06667   1.00834   1.00214   1.0025    1.0       1.00005   1.00076   1.00244   1.01642   1.10342  1.04904   2.01386  1.0       1.20604   0.447666  0.959066  1.0      1.0
    1.1889    1.38177   0.961218  1.02115   1.00327   1.00079   1.00184   1.00005   1.0       1.0012    1.00319   1.00565   1.00819  1.01083   1.99639  1.0       1.19933   1.0       0.982652  1.0      1.0
    1.33057   1.47261   1.03868   1.09218   1.02566   1.00916   1.00602   1.00076   1.0012    1.0       0.999763  1.00163   1.05537  1.02894   3.0212   1.0       1.23327   0.569681  0.956076  1.0      1.0
    1.37985   1.52098   1.04617   1.13453   1.05004   1.02128   1.00989   1.00244   1.00319   0.999763  1.0       0.998793  1.00115  1.00223   3.16914  1.0       1.25612   1.0       1.01345   1.0      1.0
    1.44925   1.73328   1.07446   1.16864   1.06369   1.03318   1.01395   1.01642   1.00565   1.00163   0.998793  1.0       1.00024  1.00719   2.19156  1.0       1.27657   0.662072  1.0       1.0      1.0
    1.52853   1.74912   1.14067   1.05603   1.10997   1.0141    1.01782   1.10342   1.00819   1.05537   1.00115   1.00024   1.0      1.00018   2.23435  1.0       1.29407   1.0       1.08656   1.0      1.0
    1.56823   1.82216   1.14551   1.23719   1.14091   1.07647   1.02162   1.04904   1.01083   1.02894   1.00223   1.00719   1.00018  1.0       3.786    1.0       1.80357   0.740416  1.10369   1.0      1.0
    1.35264   1.1757    1.78292   1.90201   2.30822   2.50926   1.89531   2.01386   1.99639   3.0212    3.16914   2.19156   2.23435  3.786     1.0      1.0       1.3775    1.0       1.0       1.0      1.0
    0.95      0.993425  1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0      1.0       1.0       0.964768  1.0       1.0      0.99043
    0.987473  0.968808  1.0       1.06922   1.19756   1.17392   1.16139   1.20604   1.19933   1.23327   1.25612   1.27657   1.29407  1.80357   1.3775   1.0       1.0       1.0       1.02275   1.0      0.954216
    0.775811  0.995157  0.775454  1.0       0.600341  0.615513  1.0       0.447666  1.0       0.569681  1.0       0.662072  1.0      0.740416  1.0      0.964768  1.0       1.0       0.940587  1.0      1.07094
    0.961156  0.960174  0.926019  0.902737  0.905829  0.926157  0.937131  0.959066  0.982652  0.956076  1.01345   1.0       1.08656  1.10369   1.0      1.0       1.02275   0.940587  1.0       1.0      1.0
    3.15978   1.47183   3.20746   1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0      1.0       1.0       1.0       1.0       1.0      1.0
    0.989843  0.990035  1.05097   1.0       1.0       1.24504   1.0       1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0      0.99043   0.954216  1.07094   1.0       1.0      1.0])

    gamma_v = PairParam("γ_v",components,[
    1.0       1.01395   1.00281   1.00662  1.03847   1.04538  1.05432   1.12451   1.34369   1.05264   1.15666  1.11655   1.1419    1.14609   1.0187    1.0       1.0061    1.58502   1.04016   0.881406  1.01468
    1.01395   1.0       1.04758   1.04235  1.08103   1.14695  1.10058   1.07888   1.15414   1.19595   1.40455  1.18607   1.10041   1.0       0.970115  1.00869   1.09475   0.997082  1.25684   0.93263   1.00221
    1.00281   1.04758   1.0       1.03288  1.0476    1.22244  1.08191   1.06841   1.11679   0.851344  1.16459  1.10404   0.973386  1.18339   1.15279   1.0       1.0       1.54233   1.02409   0.864142  1.02921
    1.00662   1.04235   1.03288   1.0      1.00303   1.00618  1.00662   1.02609   1.04544   1.1697    1.05767  1.07192   1.14353   1.09836   1.10607   1.0       1.20142   1.0       1.03099   1.0       1.0
    1.03847   1.08103   1.0476    1.00303  1.0       1.00326  1.00116   1.01992   0.999432  1.05787   1.07965  1.10276   1.19977   1.05304   1.07401   1.0       1.10814   1.01176   1.01059   1.0       1.0
    1.04538   1.14695   1.22244   1.00618  1.00326   1.0      1.00041   1.01816   1.00273   1.035     1.01917  1.04691   1.04922   1.02785   1.23294   1.0       1.08474   1.22364   1.03337   1.0       1.21464
    1.05432   1.10058   1.08191   1.00662  1.00116   1.00041  1.0       1.00278   1.00228   1.01049   1.02167  1.03281   1.0473    1.06024   1.1476    1.0       1.08727   1.0       0.988591  1.0       1.0
    1.12451   1.07888   1.06841   1.02609  1.01992   1.01816  1.00278   1.0       1.00002   1.00248   1.00897  1.06922   1.03491   1.01637   1.18833   1.0       1.11995   0.956677  1.07654   1.0       1.0
    1.34369   1.15414   1.11679   1.04544  0.999432  1.00273  1.00228   1.00002   1.0       1.003     1.00993  1.01788   1.02899   1.03937   1.18434   1.0       1.11669   1.0       0.835763  1.0       1.0
    1.05264   1.19595   0.851344  1.1697   1.05787   1.035    1.01049   1.00248   1.003     1.0       1.00151  1.00627   1.02076   1.01351   1.24346   1.0       1.15515   1.17022   1.33928   1.0       1.0
    1.15666   1.40455   1.16459   1.05767  1.07965   1.01917  1.02167   1.00897   1.00993   1.00151   1.0      1.00677   1.00137   1.00297   1.15913   1.0       1.19035   1.0       1.08796   1.0       1.0
    1.11655   1.18607   1.10404   1.07192  1.10276   1.04691  1.03281   1.06922   1.01788   1.00627   1.00677  1.0       1.00136   1.00255   1.30525   1.0       1.21921   0.599484  1.0       1.0       1.0
    1.1419    1.10041   0.973386  1.14353  1.19977   1.04922  1.0473    1.03491   1.02899   1.02076   1.00137  1.00136   1.0       1.00081   1.34265   1.0       1.25215   1.0       1.08291   1.0       1.0
    1.14609   1.0       1.18339   1.09836  1.05304   1.02785  1.06024   1.01637   1.03937   1.01351   1.00297  1.00255   1.00081   1.0       1.12023   1.0       0.870185  0.551405  1.17171   1.0       1.0
    1.0187    0.970115  1.15279   1.10607  1.07401   1.23294  1.1476    1.18833   1.18434   1.24346   1.15913  1.30525   1.34265   1.12023   1.0       1.0       1.12142   1.0       1.0       1.0       1.0
    1.0       1.00869   1.0       1.0      1.0       1.0      1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.14317   1.0       1.0       0.993907
    1.0061    1.09475   1.0       1.20142  1.10814   1.08474  1.08727   1.11995   1.11669   1.15515   1.19035  1.21921   1.25215   0.870185  1.12142   1.0       1.0       1.0       1.10173   1.0       1.15972
    1.58502   0.997082  1.54233   1.0      1.01176   1.22364  1.0       0.956677  1.0       1.17022   1.0      0.599484  1.0       0.551405  1.0       1.14317   1.0       1.0       1.01483   1.0       1.03899
    1.04016   1.25684   1.02409   1.03099  1.01059   1.03337  0.988591  1.07654   0.835763  1.33928   1.08796  1.0       1.08291   1.17171   1.0       1.0       1.10173   1.01483   1.0       1.0       1.0
    0.881406  0.93263   0.864142  1.0      1.0       1.0      1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0
    1.01468   1.00221   1.02921   1.0      1.0       1.21464  1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0       0.993907  1.15972   1.03899   1.0       1.0       1.0])

    beta_T = PairParam("β_T",components,[
    1.0       0.998099  1.02262   0.996337  0.98968  0.994175  0.980316  0.992128  1.0       0.981845  0.977432  0.957474  0.947717  0.937778  1.0       1.0       0.987412  1.06333   1.01109   1.0       0.990954
    1.0019    1.0       1.00589   1.00767   1.00268  0.994515  0.992868  1.0       1.0       1.0       1.0       1.0       0.956379  0.957934  0.946134  1.0       1.0       0.997191  1.00469   0.692869  0.99907
    0.977876  0.99414   1.0       1.01387   1.03362  1.01817   1.02334   1.027     1.01918   1.0       1.01181   1.02969   1.00769   1.02003   0.94232   1.0       1.0       0.997372  1.01603   0.768378  0.996513
    1.00368   0.992387  0.986319  1.0       0.9962   0.999131  1.0       0.998689  1.0       1.0       1.0       0.984068  1.0       0.970918  0.93297   1.0       1.0       1.0       0.990197  1.0       1.0
    1.01043   0.99733   0.967473  1.00381   1.0      1.00031   0.998012  0.996484  0.994364  1.0       1.0       1.0       1.0       0.985331  1.0       1.0       1.0       1.0       0.992574  1.0       1.0
    1.00586   1.00552   0.982153  1.00087   0.99969  1.0       1.00008   1.0       1.0       1.0       1.0       1.0       1.0       0.993688  1.0       1.0       1.0       1.0       0.985963  1.0       1.0
    1.02008   1.00718   0.977192  1.0       1.00199  0.999922  1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       0.974551  1.0       1.0
    1.00793   1.0       0.973709  1.00131   1.00353  1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       0.962007  1.0       1.0
    1.0       1.0       0.98118   1.0       1.00567  1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0
    1.01849   1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       0.997641  1.0       1.0       1.0       1.0       0.985891  1.0       1.0
    1.02309   1.0       0.988331  1.0       1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       0.988937  1.0       1.0
    1.04442   1.0       0.971165  1.01619   1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0
    1.05517   1.04561   0.99237   1.0       1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0
    1.06635   1.04391   0.980364  1.02995   1.01489  1.00635   1.0       1.0       1.0       1.00236   1.0       1.0       1.0       1.0       1.06482   1.0       1.04959   0.897162  0.973091  1.0       1.0
    1.0       1.05693   1.06121   1.07185   1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       0.939128  1.0       1.0       1.0       1.0       1.0       1.0       1.0
    1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.00002
    1.01275   1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       0.952749  1.0       1.0       1.0       1.0       1.02554   1.0       1.0
    0.940438  1.00282   1.00263   1.0       1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.11463   1.0       1.0       1.0       1.0       1.0       1.0       1.0
    0.989032  0.99533   0.984218  1.0099    1.00748  1.01424   1.02611   1.03949   1.0       1.01431   1.01119   1.0       1.0       1.02765   1.0       1.0       0.975099  1.0       1.0       1.0       1.0
    1.0       1.44327   1.30144   1.0       1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0
    1.00913   1.00093   1.0035    1.0       1.0      1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       0.999977  1.0       1.0       1.0       1.0       1.0])

    beta_v = PairParam("β_v",components,[
    1.0       0.998721  0.999518  0.997548  1.00483   0.979106  1.01124   0.94833   1.0      0.958015  0.962051  0.994741  1.00285  1.03309   1.0       1.0      0.997341  1.01278   1.0126    1.0       1.03463
    1.00128   1.0       0.977795  0.97888   0.974425  0.996083  0.986416  1.0       1.0      1.0       1.0       1.0       1.0      1.0       0.972532  1.0      1.0       0.999522  0.910394  0.969501  1.00417
    1.00048   1.02271   1.0       1.00253   0.996898  1.17476   1.07655   1.02431   1.06079  1.0       1.20547   1.02617   1.0      1.00015   0.904142  1.0      1.0       0.949056  0.906631  0.846648  1.00839
    1.00246   1.02158   0.997481  1.0       0.997607  0.999157  1.0       0.993851  1.0      1.0       1.0       1.00747   1.0      0.995676  0.925367  1.0      1.0       1.0       1.01082   1.0       1.0
    0.995196  1.02625   1.00311   1.0024    1.0       0.999796  0.999243  1.04492   1.04046  1.0       1.0       1.0       1.0      0.984104  1.0       1.0      1.0       1.0       0.936811  1.0       1.0
    1.02134   1.00393   0.851237  1.00084   1.0002    1.0       1.00088   1.0       1.0      1.0       1.0       1.0       1.0      0.976952  1.0       1.0      1.0       1.0       0.908113  1.0       1.0
    0.988885  1.01377   0.928892  1.0       1.00076   0.99912   1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.0      1.0       1.0       1.01299   1.0       1.0
    1.05449   1.0       0.976266  1.00619   0.957012  1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.0      1.0       1.0       0.984613  1.0       1.0
    1.0       1.0       0.942691  1.0       0.961114  1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.0      1.0       1.0       1.0       1.0       1.0
    1.04382   1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.00152   1.0       1.0      1.0       1.0       0.754474  1.0       1.0
    1.03945   1.0       0.829552  1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.0      1.0       1.0       0.828967  1.0       1.0
    1.00529   1.0       0.974498  0.992586  1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.0      1.0       1.0       1.0       1.0       1.0
    0.997156  1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.0      1.0       1.0       1.0       1.0       1.0
    0.967973  1.0       0.999849  1.00434   1.01615   1.02359   1.0       1.0       1.0      0.998486  1.0       1.0       1.0      1.0       1.69536   1.0      1.0       1.0       0.975188  1.0       1.0
    1.0       1.02824   1.10602   1.08065   1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      0.589846  1.0       1.0      1.0       1.0       1.0       1.0       1.0
    1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.0      1.0       1.0       1.0       1.0       0.999747
    1.00267   1.0       1.0       1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.0      1.0       1.0       0.79566   1.0       1.0
    0.987378  1.00048   1.05368   1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.0      1.0       1.0       1.0       1.0       1.0
    0.987558  1.09843   1.10299   0.989298  1.06745   1.10118   0.987172  1.01563   1.0      1.32543   1.20632   1.0       1.0      1.02544   1.0       1.0      1.25682   1.0       1.0       1.0       1.0
    1.0       1.03146   1.18113   1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.0      1.0       1.0       1.0       1.0       1.0
    0.966529  0.995851  0.991677  1.0       1.0       1.0       1.0       1.0       1.0      1.0       1.0       1.0       1.0      1.0       1.0       1.00025  1.0       1.0       1.0       1.0       1.0])

    n = SingleParam("nᵢ",components, [
    [0.57335704239162, -1.676068752373, 0.23405291834916, -0.21947376343441, 0.016369201404128, 0.01500440638928, 0.098990489492918, 0.58382770929055, -0.7478686756039, 0.30033302857974, 0.20985543806568, -0.018590151133061, -0.15782558339049, 0.12716735220791, -0.032019743894346, -0.068049729364536, 0.024291412853736, 0.0051440451639444, -0.019084949733532, 0.0055229677241291, -0.0044197392976085, 0.040061416708429, -0.033752085907575, -0.0025127658213357],
    [0.59889711801201, -1.6941557480731, 0.24579736191718, -0.23722456755175, 0.017954918715141, 0.014592875720215, 0.10008065936206, 0.73157115385532, -0.88372272336366, 0.31887660246708, 0.20766491728799, -0.019379315454158, -0.16936641554983, 0.13546846041701, -0.033066712095307, -0.060690817018557, 0.012797548292871, 0.0058743664107299, -0.018451951971969, 0.0047226622042472, -0.0052024079680599, 0.043563505956635, -0.036251690750939, -0.0028974026866543],
    [0.52646564804653, -1.4995725042592, 0.27329786733782, 0.12949500022786, 0.15404088341841, -0.58186950946814, -0.18022494838296, -0.095389904072812, -0.0080486819317679, -0.03554775127309, -0.28079014882405, -0.082435890081677, 0.010832427979006, -0.0067073993161097, -0.0046827907600524, -0.028359911832177, 0.019500174744098, -0.21609137507166, 0.43772794926972, -0.22130790113593, 0.015190189957331, -0.0153809489533],
    [0.63596780450714, -1.7377981785459, 0.28914060926272, -0.33714276845694, 0.022405964699561, 0.015715424886913, 0.11450634253745, 1.0612049379745, -1.2855224439423, 0.39414630777652, 0.31390924682041, -0.021592277117247, -0.21723666564905, -0.28999574439489, 0.42321173025732, 0.04643410025926, -0.13138398329741, 0.011492850364368, -0.033387688429909, 0.015183171583644, -0.0047610805647657, 0.046917166277885, -0.039401755804649, -0.0032569956247611],
    [1.0403973107358, -2.8318404081403, 0.84393809606294, -0.076559591850023, 0.09469737305728, 0.00024796475497006, 0.2774376042287, -0.043846000648377, -0.2699106478435, -0.06931341308986, -0.029632145981653, 0.01404012675138],
    [1.0626277411455, -2.862095182835, 0.88738233403777, -0.12570581155345, 0.10286308708106, 0.00025358040602654, 0.32325200233982, -0.037950761057432, -0.32534802014452, -0.079050969051011, -0.020636720547775, 0.005705380933475],
    [1.04293315891, -2.8184272548892, 0.8617623239785, -0.10613619452487, 0.098615749302134, 0.00023948208682322, 0.3033000485695, -0.041598156135099, -0.29991937470058, -0.080369342764109, -0.029761373251151, 0.01305963030314],
    [1.0968643098001, -2.9988888298061, 0.99516886799212, -0.16170708558539, 0.11334460072775, 0.00026760595150748, 0.40979881986931, -0.040876423083075, -0.38169482469447, -0.10931956843993, -0.03207322332799, 0.016877016216975],
    [1.0963, -3.0402, 1.0317, -0.1541, 0.11535, 0.00029809, 0.39571, -0.045881, -0.35804, -0.10107, -0.035484, 0.018156],
    [1.0553238013661, -2.6120615890629, 0.7661388296726, -0.29770320622459, 0.11879907733358, 0.00027922861062617, 0.46347589844105, 0.011433196980297, -0.48256968738131, -0.093750558924659, -0.0067273247155994, -0.0051141583585428],
    [1.0543747645262, -2.6500681506144, 0.81730047827543, -0.30451391253428, 0.122538687108, 0.00027266472743928, 0.4986582568167, -0.00071432815084176, -0.5423689552545, -0.13801821610756, -0.0061595287380011, 0.00048602510393022],
    [1.0722544875633, -2.4632951172003, 0.65386674054928, -0.36324974085628, 0.12713269626764, 0.0003071357277793, 0.5265685698754, 0.019362862857653, -0.58939426849155, -0.14069963991934, -0.0078966330500036, 0.0033036597968109],
    [1.1151, -2.702, 0.83416, -0.38828, 0.1376, 0.00028185, 0.62037, 0.015847, -0.61726, -0.15043, -0.012982, 0.0044325],
    [1.0461, -2.4807, 0.74372, -0.52579, 0.15315, 0.00032865, 0.84178, 0.055424, -0.73555, -0.18507, -0.020775, 0.012335],
    [5.3579928451252, -6.2050252530595, 0.13830241327086, -0.071397954896129, 0.015474053959733, -0.14976806405771, -0.026368723988451, 0.056681303156066, -0.060063958030436, -0.45043942027132, 0.424788402445, -0.021997640827139, -0.01049952137453, -0.0028955902866816],
    [0.88878286369701, -2.4879433312148, 0.59750190775886, 0.0096501817061881, 0.07197042871277, 0.00022337443000195, 0.18558686391474, -0.03812936803576, -0.15352245383006, -0.026726814910919, -0.025675298677127, 0.0095714302123668],
    [0.90554, -2.4515, 0.53149, 0.024173, 0.072156, 0.00018818, 0.19405, -0.043268, -0.12778, -0.027896, -0.034154, 0.016329],
    [0.82728408749586, -1.8602220416584, -1.1199009613744, 0.15635753976056, 0.87375844859025, -0.36674403715731, 0.053987893432436, 1.0957690214499, 0.053213037828563, 0.013050533930825, -0.41079520434476, 0.1463744334412, -0.055726838623719, -0.0112017741438, -0.0066062758068099, 0.0046918522004538],
    [0.87641, -2.0367, 0.21634, -0.050199, 0.066994, 0.00019076, 0.20227, -0.0045348, -0.2223, -0.034714, -0.014885, 0.0074154],
    [-0.45579024006737, 1.2516390754925, -1.5438231650621, 0.020467489707221, -0.34476212380781, -0.020858459512787, 0.016227414711778, -0.057471818200892, 0.019462416430715, -0.03329568012302, -0.010863577372367, -0.022173365245954],
    [0.85095714803969, -2.400322294348, 0.54127841476466, 0.016919770692538, 0.068825965019035, 0.00021428032815338, 0.17429895321992, -0.033654495604194, -0.13526799857691, -0.016387350791552, -0.024987666851475, 0.0088769204815709],
    ])
    t = SingleParam("tᵢ",components,[
    [0.125, 1.125, 0.375, 1.125, 0.625, 1.5, 0.625, 2.625, 2.75, 2.125, 2.0, 1.75, 4.5, 4.75, 5.0, 4.0, 4.5, 7.5, 14.0, 11.5, 26.0, 28.0, 30.0, 16.0],
    [0.125, 1.125, 0.375, 1.125, 0.625, 1.5, 0.625, 2.625, 2.75, 2.125, 2.0, 1.75, 4.5, 4.75, 5.0, 4.0, 4.5, 7.5, 14.0, 11.5, 26.0, 28.0, 30.0, 16.0],
    [0.0, 1.25, 1.625, 0.375, 0.375, 1.375, 1.125, 1.375, 0.125, 1.625, 3.75, 3.5, 7.5, 8.0, 6.0, 16.0, 11.0, 24.0, 26.0, 28.0, 24.0, 26.0],
    [0.125, 1.125, 0.375, 1.125, 0.625, 1.5, 0.625, 2.625, 2.75, 2.125, 2.0, 1.75, 4.5, 4.75, 5.0, 4.0, 4.5, 7.5, 14.0, 11.5, 26.0, 28.0, 30.0, 16.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.5, 0.625, 0.375, 0.625, 1.125, 2.625, 0.0, 0.25, 1.375, 4.0, 4.25, 5.0, 8.0, 8.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.5, 1.25, 1.875, 0.125, 1.5, 1.0, 0.75, 1.5, 0.625, 2.625, 5.0, 4.0, 4.5, 3.0, 4.0, 6.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    [0.0, 0.125, 0.75, 1.0, 0.75, 2.625, 0.125, 1.25, 2.0, 1.0, 4.5, 5.0],
    [0.25, 1.125, 1.5, 1.375, 0.25, 0.875, 0.625, 1.75, 3.625, 3.625, 14.5, 12.0],
    ])

    d = SingleParam("dᵢ",components,
    [
    [1, 1, 2, 2, 4, 4, 1, 1, 1, 2, 3, 6, 2, 3, 3, 4, 4, 2, 3, 4, 5, 6, 6, 7],
    [1, 1, 2, 2, 4, 4, 1, 1, 1, 2, 3, 6, 2, 3, 3, 4, 4, 2, 3, 4, 5, 6, 6, 7],
    [1, 1, 2, 3, 3, 3, 4, 5, 6, 6, 1, 4, 1, 1, 3, 3, 4, 5, 5, 5, 5, 5],
    [1, 1, 2, 2, 4, 4, 1, 1, 1, 2, 3, 6, 2, 3, 3, 4, 4, 2, 3, 4, 5, 6, 6, 7],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 2, 2, 4, 1, 5, 5, 5, 1, 1, 2, 5, 1],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 2, 2, 3, 4, 1, 5, 5, 1, 2, 4, 4, 1, 1],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    [1, 1, 1, 4, 1, 3, 5, 5, 5, 2, 1, 2],
    [1, 1, 1, 2, 3, 7, 2, 5, 1, 4, 3, 4],
    ])

    c = SingleParam("cᵢ",components,
    [[1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 6, 6, 6, 6],
    [1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 6, 6, 6, 6],
    [1, 1, 1, 1, 1, 1, 2, 2, 3, 3, 3, 3, 3, 5, 5, 5, 6, 6],
    [1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 6, 6, 6, 6],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 1, 1, 2, 2, 3, 3, 5],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 1, 2, 2, 2, 3, 5, 5],
    [1, 1, 2, 2, 3, 3],
    [1, 1, 1, 1, 1, 2, 3, 3],
    [1, 1, 2, 2, 3, 3]])

    idx1 = [1, 1, 1, 1, 1, 1, 1, 2, 2, 4, 4, 4, 5, 5, 6]
    idx2 = [2, 3, 4, 5, 6, 7, 15, 3, 4, 5, 6, 7, 6, 7, 7]

    Fij = PairParam("Fᵢⱼ",components,
    sparse(idx1,idx2,[
    1.0,
    1.0,
    1.0,
    1.0,
    1.0,
    0.771035405688,
    1.0,
    1.0,
    1.0,
    0.130424765150,
    0.281570073085,
    0.260632376098,
    0.312572600489e-1,
    -0.551609771024e-1,
    -0.551240293009e-1,
    ],21,21))

    dij = PairParam("dᵢⱼ",components,
    sparse(idx1,idx2,
    [
    [1, 4, 1, 2, 2, 2, 2, 2, 3],
    [1, 2, 3, 1, 2, 3],
    [3, 4, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3],
    [3, 3, 4, 4, 4, 1, 1, 1, 2],
    [2, 3, 1, 1, 1, 2],
    [2, 2, 3, 1, 2, 2],
    [1, 3, 3, 4],
    [1, 1, 1, 2, 2, 3, 3, 4, 4, 4],
    [1, 1, 1, 2, 2, 3, 3, 4, 4, 4],
    [1, 1, 1, 2, 2, 3, 3, 4, 4, 4],
    [1, 1, 1, 2, 2, 3, 3, 4, 4, 4],
    [1, 1, 1, 2, 2, 3, 3, 4, 4, 4],
    [1, 1, 1, 2, 2, 3, 3, 4, 4, 4],
    [1, 1, 1, 2, 2, 3, 3, 4, 4, 4],
    [1, 1, 1, 2, 2, 3, 3, 4, 4, 4],
    ],21,21
    ))

    tij = PairParam("tᵢⱼ",components,
    sparse(idx1,idx2,[
    [0.000, 1.850, 7.850, 5.400, 0.000, 0.750, 2.800, 4.450, 4.250],
    [2.600, 1.950, 0.000, 3.950, 7.950, 8.000],
    [0.650, 1.550, 3.100, 5.900, 7.050, 3.350, 1.200, 5.800, 2.700, 0.450, 0.550, 1.950],
    [1.850, 3.950, 0.000, 1.850, 3.850, 5.250, 3.850, 0.200, 6.500],
    [1.850, 1.400, 3.200, 2.500, 8.000, 3.750],
    [0.000, 0.050, 0.000, 3.650, 4.900, 4.450],
    [2.0, -1.0, 1.75, 1.4],
    [1.000, 1.550, 1.700, 0.250, 1.350, 0.000, 1.250, 0.000, 0.700, 5.400],
    [1.000, 1.550, 1.700, 0.250, 1.350, 0.000, 1.250, 0.000, 0.700, 5.400],
    [1.000, 1.550, 1.700, 0.250, 1.350, 0.000, 1.250, 0.000, 0.700, 5.400],
    [1.000, 1.550, 1.700, 0.250, 1.350, 0.000, 1.250, 0.000, 0.700, 5.400],
    [1.000, 1.550, 1.700, 0.250, 1.350, 0.000, 1.250, 0.000, 0.700, 5.400],
    [1.000, 1.550, 1.700, 0.250, 1.350, 0.000, 1.250, 0.000, 0.700, 5.400],
    [1.000, 1.550, 1.700, 0.250, 1.350, 0.000, 1.250, 0.000, 0.700, 5.400],
    [1.000, 1.550, 1.700, 0.250, 1.350, 0.000, 1.250, 0.000, 0.700, 5.400],
    ]
    ,21,21))

    nij = PairParam("nᵢⱼ",components,
    sparse(idx1,idx2,
    [
    [-0.0098038985517335, 0.00042487270143005, -0.034800214576142, -0.13333813013896, -0.011993694974627, 0.069243379775168, -0.31022508148249, 0.24495491753226, 0.22369816716981],
    [-0.10859387354942, 0.080228576727389, -0.0093303985115717, 0.040989274005848, -0.24338019772494, 0.23855347281124],
    [-0.00080926050298746, -0.00075381925080059, -0.041618768891219, -0.23452173681569, 0.14003840584586, 0.063281744807738, -0.034660425848809, -0.23918747334251, 0.0019855255066891, 6.1777746171555, -6.9575358271105, 1.0630185306388],
    [0.013746429958576, -0.0074425012129552, -0.0045516600213685, -0.0054546603350237, 0.0023682016824471, 0.18007763721438, -0.44773942932486, 0.0193273748882, -0.30632197804624],
    [0.28661625028399, -0.10919833861247, -1.137403208227, 0.76580544237358, 0.0042638000926819, 0.17673538204534],
    [-0.47376518126608, 0.48961193461001, -0.0057011062090535, -0.1996682004132, -0.69411103101723, 0.69226192739021],
    [-0.25157134971934, -0.0062203841111983, 0.088850315184396, -0.035592212573239],
    [2.5574776844118, -7.9846357136353, 4.7859131465806, -0.73265392369587, 1.3805471345312, 0.28349603476365, -0.49087385940425, -0.10291888921447, 0.11836314681968, 5.5527385721943e-5],
    [2.5574776844118, -7.9846357136353, 4.7859131465806, -0.73265392369587, 1.3805471345312, 0.28349603476365, -0.49087385940425, -0.10291888921447, 0.11836314681968, 5.5527385721943e-5],
    [2.5574776844118, -7.9846357136353, 4.7859131465806, -0.73265392369587, 1.3805471345312, 0.28349603476365, -0.49087385940425, -0.10291888921447, 0.11836314681968, 5.5527385721943e-5],
    [2.5574776844118, -7.9846357136353, 4.7859131465806, -0.73265392369587, 1.3805471345312, 0.28349603476365, -0.49087385940425, -0.10291888921447, 0.11836314681968, 5.5527385721943e-5],
    [2.5574776844118, -7.9846357136353, 4.7859131465806, -0.73265392369587, 1.3805471345312, 0.28349603476365, -0.49087385940425, -0.10291888921447, 0.11836314681968, 5.5527385721943e-5],
    [2.5574776844118, -7.9846357136353, 4.7859131465806, -0.73265392369587, 1.3805471345312, 0.28349603476365, -0.49087385940425, -0.10291888921447, 0.11836314681968, 5.5527385721943e-5],
    [2.5574776844118, -7.9846357136353, 4.7859131465806, -0.73265392369587, 1.3805471345312, 0.28349603476365, -0.49087385940425, -0.10291888921447, 0.11836314681968, 5.5527385721943e-5],
    [2.5574776844118, -7.9846357136353, 4.7859131465806, -0.73265392369587, 1.3805471345312, 0.28349603476365, -0.49087385940425, -0.10291888921447, 0.11836314681968, 5.5527385721943e-5],
    ],21,21))

    eta_ij = PairParam("ηᵢⱼ",components,
    sparse(idx1,idx2,
    [
    [1.000, 1.000, 0.250, 0.000, 0.000, 0.000, 0.000],
    [1.000, 0.500, 0.000],
    [1.000, 1.000, 1.000, 0.875, 0.750, 0.500, 0.000, 0.000, 0.000, 0.000],
    [0.250, 0.250, 0.000, 0.000],
    [0.250, 0.250, 0.000, 0.000],
    [1.000, 1.000, 0.875],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    ],
     21, 21)
    )

    epsilon_ij = PairParam("εᵢⱼ",components,
    sparse(idx1,idx2,
    [
    [0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5],
    [0.5, 0.5, 0.5],
    [0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5],
    [0.5, 0.5, 0.5, 0.5],
    [0.5, 0.5, 0.5, 0.5],
    [0.5, 0.5, 0.5],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    ],
    21, 21)
    )

    beta_ij = PairParam("εᵢⱼ",components,
    sparse(idx1,idx2,
    [
    [1.000, 1.000, 2.500, 3.000, 3.000, 3.000, 3.000],
    [1.000, 2.000, 3.000],
    [1.000, 1.000, 1.000, 1.250, 1.500, 2.000, 3.000, 3.000, 3.000, 3.000],
    [0.750, 1.000, 2.000, 3.000],
    [0.750, 1.000, 2.000, 3.000],
    [1.000, 1.000, 1.250],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    ],
    21, 21)
    )
    gamma_ij = PairParam("γᵢⱼ",components,
    sparse(idx1, idx2,
    [
    [0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5],
    [0.5, 0.5, 0.5],
    [0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5],
    [0.5, 0.5, 0.5, 0.5],
    [0.5, 0.5, 0.5, 0.5],
    [0.5, 0.5, 0.5],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    Float64[],
    ],
    21, 21)
    )
    return Dict{Symbol,Any}(
        :Mw => Mw,
        :rhoc =>rhoc,
        :Tc =>Tc,
        :pc =>pc,
        :lb_v =>lb_v,
        :n0 =>n0,
        :theta =>theta,
        :gamma_T =>gamma_T,
        :gamma_v =>gamma_v,
        :beta_T =>beta_T,
        :beta_v =>beta_v,
        :n =>n,
        :t =>t,
        :d =>d,
        :c =>c,
        :nij =>nij,
        :tij =>tij,
        :dij =>dij,    
        :Fij =>Fij,
        :eta_ij =>eta_ij,
        :epsilon_ij =>epsilon_ij,
        :beta_ij =>beta_ij,
        :gamma_ij =>gamma_ij,
    )
end

function getnames_gerg2008(components::Vector{String})
    comps = normalisestring.(components)
    names = normalisestring.(GERG2008_names)
    @assert allunique(comps)
    res = indexin(comps,names)
    if any(isnothing,res)
        idx = findfirst(isnothing,res)
        throw(error("component $(components[idx]) could not be found"))
    end
    return res
end

function f(s)
    state = zeros(Int, 2)
    state = state
    code = Meta.parse.(s)
    for c in code
        println(@macroexpand(@eval($c))) 
        
    end
    return state
end

